'Compilable Example:
#Compile Exe "gbvideo.exe"
#Dim All
#Debug Error On
#Debug Display On

%Unicode = 1
#Include "Win32API.inc"
#Include Once "dshow.inc"
#Include Once "ole2utils.inc"   ' For IUnknown_Release
#Include "cgdiplus.inc"
#Include "SAPI.inc"

#Resource Icon logo     "icons\logo.ico"
#Resource Icon xhelp     "icons\help.ico"
#Resource Icon xcopy     "icons\copy.ico"
#Resource Icon xxprint   "icons\print.ico"
#Resource Icon xcamera   "icons\camera.ico"
#Resource Icon xsettings "icons\settings.ico"
#Resource Icon xlist     "icons\list.ico"
#Resource Icon xzoomin   "icons\zoomin.ico"
#Resource Icon xzoomout  "icons\zoomout.ico"
#Resource Icon xnext     "icons\next.ico"
#Resource Icon xborder   "icons\border.ico"
#Resource Icon xfill     "icons\fill.ico"
#Resource Icon xcolors   "icons\colors.ico"
#Resource Icon xcaption  "icons\caption.ico"
#Resource Icon xedit     "icons\edit.ico"
#Resource Icon xbinary   "icons\binary.ico"
#Resource Icon xplay     "icons\play.ico"
#Resource Icon xpause    "icons\pause.ico"
#Resource Icon xplus     "icons\plus.ico"
#Resource Icon xminus    "icons\minus.ico"

#Resource Wave xcamera   "icons\camera.wav"

$Ver = "0.44"
%WM_GraphNotify = %WM_User+13

$LogiTech = "Logitech HD Pro Webcam C920"
$Elmo     = "TX-1/LX-1"

Type QualitySettings
   name As StringZ * 50
   max As Long
   min As Long
   step As Long
   val As Long
   default As Long
   type As Long
   delta As Long
End Type

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDC_Toolbar = 500
   IDC_ListView

   IDT_Copy
   IDT_Print

   IDT_Next
   IDT_ZoomIn
   IDT_ZoomOut

   IDT_List
   IDT_Plus
   IDT_Minus
   IDT_Fill
   IDT_Border
   IDT_ShowCaption
   IDT_Binary
   IDT_TextColor
   IDT_BGColor
   IDT_BorderColor
   IDT_EnterCaption
   IDT_Settings
   IDT_Help

   IDM_Exit
   IDM_Restore
   IDM_Sep

   ListType_None = 0
   ListType_Cameras
   ListType_Quality
End Enum

Global pWindow         As IVideoWindow            'Display Window
Global pGraph          As IGraphBuilder           'Filter Graph Manager
Global pBuild          As ICaptureGraphBuilder2   'Capture Graph Builder
Global pSysDevEnum     As ICreateDevEnum          'enumeration object
Global pEnumCat        As IEnumMoniker
Global pControl        As IMediaControl
'Global pEvents         As IMediaEventEX
Global pMoniker        As IMoniker                'contains information about other objects
Global pCap            As IBaseFilter             'Video capture filter
Global pbc             As IBindCTX
Global pPropBag        As IPropertyBag
Global pConfig         As IAMStreamConfig   'video output format
Global pProcAmp        As IAMVideoProcAmp   'backlight comp, brightness, contrast, gain, gamme, hue, saturation, sharpness, whitebalance
Global pCamControl     As IAMCameraControl  'exposure, focus, zoom
'Global pGrabber        AS ISampleGrabber

Global hDlg, hToolBar, hListView, hContext, hFont As Dword
Global ghHook, hGraphic, hImageList, hBorderBrush As Dword
Global Q() As QualitySettings, CameraRC As Rect
Global CustomColorList As CustomColors
Global hr As Dword, Factor As Single
Global Cameras() As String, Resolutions() As Point
Global NoCamera, Zoomed, TBH, CameraCount As Long
Global xImg, yImg, wTrue, hTrue, wMod, hMod As Long                   'loc/pos of video

'INI
Global CaptionX, CameraName As WStringZ*%Max_Path
Global CopyCount, FillMode, Zoom, EditFrames, BorderColor, BinaryMode As Long
Global MiniBar, TextColor, BGColor, ShowCaption, BorderSize, ListType As Long

Function PBMain() As Long
   Dialog Default Font "Tahoma", 12, 1
   Dialog New Pixels, 0, "gbVideo   v" + $Ver,,,1200,900, %WS_OverlappedWindow Or %WS_ClipSiblings Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg, "logo"
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local w,h,iRow As Long, hDC As Dword, LVNT As NMItemActivate Ptr
   Local PS As PaintStruct, P As TOOLTIPTEXT Ptr, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         Font New "Tahomas", 24, 1 To hFont
         If IsFalse IsFolder("images") Then MkDir "images"
         BuildAcceleratorTable
         CreateInterfaces
         Settings_INI "get"
         CreateToolbar
         CreateListView
         CreateContextMenu

         If Zoomed = %SW_ShowMaximized Then Dialog Maximize hDlg
         If Zoomed = %SW_ShowMinimized Then Dialog Minimize hDlg
         GetCameraList
         If NoCamera = 0 Then
            DisplayVideo
            GetSettings
            SetMenusAndToolbar
         End If
         LoadListView

      Case %WM_Destroy
         Settings_INI "save"

      Case %WM_Size : ResizeWindow

      Case %WM_Paint
         Dialog Get Client hDlg To w,h
         hDC = BeginPaint(hDlg, PS)
         hBorderBrush = CreateSolidBrush(BorderColor)
         FillRect(hDC, CameraRC, hBorderBrush)
         EndPaint hDlg, PS

      Case %WM_ContextMenu
         TrackPopupMenu hContext, %TPM_LeftAlign, Lo(Integer,Cb.LParam), Hi(Integer,Cb.LParam), 0, Cb.Hndl, ByVal 0

      Case %WM_Help
         w = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbvideo.htm", $Nul, $Nul, %SW_ShowNormal)

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_List
               Incr ListType : If ListType > %ListType_Quality Then ListType = %ListType_None
               GetSettings : LoadListView  : ResizeWindow : SetMenusAndToolbar
            Case %IDT_Copy          : CopyToClipboard
            Case %IDT_Print         : PrintImage
            Case %IDT_Next          : NextCamera
            Case %IDT_ZoomIn        : ZoomIn
            Case %IDT_ZoomOut       : ZoomOut
            Case %IDT_Fill          : FillMode Xor= 1    : ReSizeWindow : SetMenusAndToolbar
            Case %IDT_Border        : ToggleBorderSize   : ReSizeWindow : SetMenusAndToolbar
            Case %IDT_BorderColor   : BorderColor = SelectColor(BorderColor) : Dialog ReDraw hDlg
            Case %IDT_ShowCaption   : ShowCaption Xor= 1 : ReSizeWindow : SetMenusAndToolbar
            Case %IDT_Binary        : ToggleBinaryMode
            Case %IDT_TextColor     : TextColor   = SelectColor(TextColor)
            Case %IDT_BGColor       : BGColor     = SelectColor(BGColor)
            Case %IDT_EnterCaption  : EnterCaption
            Case %IDT_Plus          : ChangeSetting(+1)
            Case %IDT_Minus         : ChangeSetting(-1)
            Case %IDT_Settings      : ToggleMiniBar
            Case %IDT_Help          : w = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbvideo.htm", $Nul, $Nul, %SW_ShowNormal)
            Case %IDM_Restore       : RestoreDefaultSettings
            Case %IDM_Exit          : Dialog End hDlg
         End Select

      Case %WM_Notify
         If Cb.NmCode = %TTN_GetDispInfo Then
            P = Cb.LParam
            Select Case Cb.NmId          'or this:   @P.hdr.idFrom
               Case %IDT_List         : @P.@lpszText = "Toggle List Diplays"
               Case %IDT_Copy         : @P.@lpszText = "Copy Image to Clipboard And Save to File"
               Case %IDT_Print        : @P.@lpszText = "Print Image"
               Case %IDT_Next         : @P.@lpszText = "Display Next Camera"
               Case %IDT_ZoomIn       : @P.@lpszText = "Zoom In"
               Case %IDT_ZoomOut      : @P.@lpszText = "Zoom Out"
               Case %IDT_Fill         : @P.@lpszText = "Toggle Image Fit"
               Case %IDT_Border       : @P.@lpszText = "Toggle Border Sizes"
               Case %IDT_BorderColor  : @P.@lpszText = "Set Border Color"
               Case %IDT_ShowCaption  : @P.@lpszText = "Toggle Caption Display"
               Case %IDT_Binary       : @P.@lpszText = "Toggle Binary Color Affect"
               Case %IDT_TextColor    : @P.@lpszText = "Set Caption Text Color"
               Case %IDT_BGColor      : @P.@lpszText = "Set Caption BG Color"
               Case %IDT_EnterCaption : @P.@lpszText = "Edit Caption Text"
               Case %IDT_Help         : @P.@lpszText = "Open gbVideo Web Site"
            End Select
         End If
         Select Case Cb.NmId
            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %NM_DblClk
                     If ListType = %ListType_Cameras Then
                        LVNT = Cb.LParam
                        iRow = @LVNT.iItem+1
                        ListView Get Text hDlg, %IDC_ListView, iRow,1 To temp$
                        ChangeCamera(temp$)
                     End If
               End Select
         End Select
   End Select
End Function

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(8)
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B : ac(c).cmd   = %IDT_Border       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_C : ac(c).cmd   = %IDT_Copy         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F : ac(c).cmd   = %IDT_Fill         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L : ac(c).cmd   = %IDT_List         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N : ac(c).cmd   = %IDT_Next         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P : ac(c).cmd   = %IDT_Print        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R : ac(c).cmd   = %IDM_Restore      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T : ac(c).cmd   = %IDT_Binary       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_X : ac(c).cmd   = %IDM_Exit         : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub ResizeWindow
   Local x0,y0,x,y,w,h,wCont,hCont As Long
   Dialog Get Client hDlg To w,h
   Control Show State hDlg, %IDC_ListView, IIf(ListType, %SW_Show, %SW_Hide)
   Control Set Loc hDlg, %IDC_ListView, 0,TBH
   Control Set Size hDlg, %IDC_ListView, 350, h - TBH

   Select Case CameraName
      Case $LogiTech  : wTrue = 800 : hTrue = 600
      Case $Elmo      : wTrue = 1920 : hTrue = 1080
      Case Else       : wTrue = 800 : hTrue = 600
   End Select
   Factor = 1.0

   If IsObject(pWindow) Then
      Select Case FillMode
         Case 0  'Inside Boundary
            x0 = IIf(ListType,1,0)*350 + BorderSize
            y0 = TBH + BorderSize
            wCont = w - x0 - BorderSize  'width
            hCont = h - TBH - 2*BorderSize      'height
            wMod = wTrue / Max(wTrue / wCont, hTrue / hCont)
            hMod = hTrue / Max(wTrue / wCont, hTrue / hCont)
            xImg = x0 + (wCont-wMod)/2 + (1-Factor)*wCont/2
            yIMg = y0 + (hCont-hMod)/2 + (1-Factor)*hCont/2  'upper/left position so resized image is centered
         Case 1  'Allow Distortion
            xImg = IIf(ListType,1,0)*350 + BorderSize
            yImg = TBH + BorderSize
            wMod  = w - xImg - BorderSize  'width
            hMod  = h - TBH - 2*BorderSize      'height
      End Select
      SetCameraRC
      If NoCamera = 0 Then pWindow.SetWindowPosition(xImg,yImg,wMod,hMod)
      Dialog ReDraw hDlg
'      RedrawWindow hDlg, CameraRC, 0, %RDW_INVALIDATE Or %RDW_UPDATENOW
   End If
End Sub

Sub CreateToolbar
   Local w As Long
    Control Kill hDlg, %IDC_Toolbar
    ImageList Kill hImageList

    ImageList New Icon 24,24,32,25 To hImageList
    ImageList Add Icon hImageList, "xcopy"        '1
    ImageList Add Icon hImageList, "xxprint"      '2
    ImageList Add Icon hImageList, "xhelp"        '3
    ImageList Add Icon hImageList, "xcamera"      '4
    ImageList Add Icon hImageList, "xlist"        '5
    ImageList Add Icon hImageList, "xzoomin"      '6
    ImageList Add Icon hImageList, "xzoomout"     '7
    ImageList Add Icon hImageList, "xnext"        '8
    ImageList Add Icon hImageList, "xborder"      '9
    ImageList Add Icon hImageList, "xfill"       '10
    ImageList Add Icon hImageList, "xcolors"     '11
    ImageList Add Icon hImageList, "xcaption"    '12
    ImageList Add Icon hImageList, "xedit"       '13
    ImageList Add Icon hImageList, "xplay"       '14
    ImageList Add Icon hImageList, "xpause"      '15
    ImageList Add Icon hImageList, "xsettings"   '16
    ImageList Add Icon hImageList, "xbinary"     '17
    ImageList Add Icon hImageList, "xplus"       '18
    ImageList Add Icon hImageList, "xminus"      '19

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child Or %TbStyle_Tooltips
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0
    Toolbar Add Button    hDlg, %IDC_Toolbar,   8, %IDT_Next, %BTNS_Button, "Next"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,   6, %IDT_ZoomIn, %BTNS_Button, "In"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,   7, %IDT_ZoomOut, %BTNS_Button, "Out"
    If MiniBar = 0 Then Toolbar Add Separator hDlg, %IDC_ToolBar, 24
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,   5, %IDT_List, %BTNS_Button, "List"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  18, %IDT_Plus, %BTNS_Button, "Plus"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  19, %IDT_Minus, %BTNS_Button, "Minus"
    If MiniBar = 0 Then Toolbar Add Separator hDlg, %IDC_ToolBar, 24
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  10, %IDT_Fill, %BTNS_Button, "Fit"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  17, %IDT_Binary, %BTNS_Button, "Binary"
    Toolbar Add Separator hDlg, %IDC_ToolBar, 24
    Toolbar Add Button    hDlg, %IDC_Toolbar,   1, %IDT_Copy, %BTNS_Button, "Copy"
    Toolbar Add Button    hDlg, %IDC_Toolbar,   2, %IDT_Print, %BTNS_Button, "Print"
    Toolbar Add Separator hDlg, %IDC_ToolBar, 24
    Toolbar Add Button    hDlg, %IDC_Toolbar,   9, %IDT_Border, %BTNS_Button, "Border"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  11, %IDT_BorderColor, %BTNS_Button, "Color"
    If MiniBar = 0 Then Toolbar Add Separator hDlg, %IDC_ToolBar, 24
    Toolbar Add Button    hDlg, %IDC_Toolbar,  12, %IDT_ShowCaption, %BTNS_Button, "Caption"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  13, %IDT_EnterCaption, %BTNS_Button, "Edit"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  11, %IDT_TextColor, %BTNS_Button, "FG"
    If MiniBar = 0 Then Toolbar Add Button    hDlg, %IDC_Toolbar,  11, %IDT_BGColor, %BTNS_Button, "BG"
    Toolbar Add Separator hDlg, %IDC_ToolBar, 24
    Toolbar Add Button    hDlg, %IDC_Toolbar, 16,  %IDT_Settings, %BTNS_Button, "Mini-Bar"
    Toolbar Add Button    hDlg, %IDC_Toolbar,  3,  %IDT_Help, %BTNS_Button, "Help"
    Control Get Size hDlg, %IDC_Toolbar   To w,TBH
End Sub

Sub SetMenusAndToolbar
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowCaption, ShowCaption * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Settings, MiniBar * %TBState_Checked Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Plus, IIf(ListType = %ListType_Quality, %TBState_Enabled, %TBState_Disabled)
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Minus, IIf(ListType = %ListType_Quality, %TBState_Enabled, %TBState_Disabled)
End Sub

Sub CreateListView
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Add ListView, hDlg, %IDC_ListView, "", 0,50,100,100, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Insert Column hDlg, %IDC_ListView, 1, "Camera"    , 100 , 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Resolution", 100 , 0
   ListView Insert Column hDlg, %IDC_ListView, 3, "", 0 , 0
   ListView Insert Column hDlg, %IDC_ListView, 4, "", 0 , 0
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_FullRowSelect Or %LVS_Ex_GridLines
End Sub

Sub CreateContextMenu
   Menu New PopUp To hContext
   Menu Add String, hContext, "Exit",    %IDM_Exit,   %MF_Enabled
   Menu Add String, hContext, "-",       %IDM_Sep,      %MF_Enabled
   Menu Add String, hContext, "Next",    %IDT_Next,   %MF_Enabled
   Menu Add String, hContext, "List",    %IDT_List,   %MF_Enabled
End Sub

Sub Settings_INI(Task$)
   Local xxResult, yResult, tempz, INIFileName As WStringZ*%Max_Path, WinPla As WindowPlacement, x As Long
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "200", xxResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "200", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xxResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "960", xxResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "450", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xxResult), Val(yResult)   'width/height

      'get value for string variables
'      Getprivateprofilestring "All", "CameraName", "Logitech HD Pro Webcam C920", CameraName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "CameraName", "Logitech HD Pro Webcam C920", CameraName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Caption", "gbVideo", CaptionX, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "Zoomed", Str$(%SW_ShowNormal),  tempz,  %Max_Path, INIFileName  : Zoomed = Val(tempz)
      Getprivateprofilestring "All", "wTrue", "800",                  tempz,  %Max_Path, INIFileName  :  wTrue = Val(tempz)
      Getprivateprofilestring "All", "hTrue", "600",                  tempz,  %Max_Path, INIFileName  :  hTrue = Val(tempz)
      Getprivateprofilestring "All", "Zoom", "100",                   tempz,  %Max_Path, INIFileName  :  Zoom = Val(tempz)

      Getprivateprofilestring "All", "ListType", "1",                 tempz,  %Max_Path, INIFileName  : ListType = Val(tempz)
      Getprivateprofilestring "All", "FillMode", "0",                 tempz,  %Max_Path, INIFileName  : FillMode = Val(tempz)
      Getprivateprofilestring "All", "BorderSize", "5",               tempz,  %Max_Path, INIFileName  : BorderSize = Val(tempz)
      Getprivateprofilestring "All", "ShowCaption", "0",              tempz,  %Max_Path, INIFileName  : ShowCaption = Val(tempz)
      Getprivateprofilestring "All", "EditFrames", "0",               tempz,  %Max_Path, INIFileName  : EditFrames = Val(tempz)

      Getprivateprofilestring "All", "TextColor", Str$(%Black),       tempz,  %Max_Path, INIFileName  : TextColor = Val(tempz)
      Getprivateprofilestring "All", "BGColor", "-2",                 tempz,  %Max_Path, INIFileName  : BGColor = Val(tempz)
      Getprivateprofilestring "All", "BorderColor", "0",              tempz,  %Max_Path, INIFileName  : BorderColor = Val(tempz)
      Getprivateprofilestring "All", "BorderColor", "0",              tempz,  %Max_Path, INIFileName  : BorderColor = Val(tempz)
      Getprivateprofilestring "All", "BinaryMode", "0",               tempz,  %Max_Path, INIFileName  : BinaryMode = Val(tempz)
      Getprivateprofilestring "All", "CopyCount", "0",                tempz,  %Max_Path, INIFileName  : CopyCount = Val(tempz)
      Getprivateprofilestring "All", "MiniBar", "0",                  tempz,  %Max_Path, INIFileName  : MiniBar = Val(tempz)

      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(x) = Val(tempz)
      Next

   End If

   If Task$ = "save" Then
      'save dialog true size/location unless minimized or maximized
      WinPla.Length = SizeOf(WinPla)
      GetWindowPlacement hDlg, WinPla
      WritePrivateProfileString "All", "Left", Str$(WinPla.rcNormalPosition.nLeft), INIFileName
      WritePrivateProfileString "All", "Top", Str$(WinPla.rcNormalPosition.nTop), INIFileName
      WritePrivateProfileString "All", "Width", Str$(WinPla.rcNormalPosition.nRight - WinPla.rcNormalPosition.nLeft), INIFileName
      WritePrivateProfileString "All", "Height", Str$(WinPla.rcNormalPosition.nBottom - WinPla.rcNormalPosition.nTop), INIFileName

      'save string variables
      WritePrivateProfileString "All", "CameraName",CameraName, INIFileName
      WritePrivateProfileString "All", "Caption",   CaptionX, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "Zoomed",         Str$(WinPla.showCmd), INIFileName
      WritePrivateProfileString "All", "wTrue",           Str$(wTrue), INIFileName
      WritePrivateProfileString "All", "hTrue",           Str$(hTrue), INIFileName
      WritePrivateProfileString "All", "Zoom",           Str$(Zoom), INIFileName

      WritePrivateProfileString "All", "ListType",       Str$(ListType), INIFileName
      WritePrivateProfileString "All", "FillMode",       Str$(FillMode), INIFileName
      WritePrivateProfileString "All", "BorderSize",     Str$(BorderSize), INIFileName
      WritePrivateProfileString "All", "ShowCaption",    Str$(ShowCaption), INIFileName
      WritePrivateProfileString "All", "EditFrames",     Str$(EditFrames), INIFileName
      WritePrivateProfileString "All", "TextColor",      Str$(TextColor), INIFileName
      WritePrivateProfileString "All", "BGColor",        Str$(BGColor), INIFileName
      WritePrivateProfileString "All", "BorderColor",    Str$(BorderColor), INIFileName
      WritePrivateProfileString "All", "BinaryMode",     Str$(BinaryMode), INIFileName
      WritePrivateProfileString "All", "CopyCount",      Str$(CopyCount), INIFileName
      WritePrivateProfileString "All", "MiniBar",        Str$(MiniBar), INIFileName

      For x = 0 To 15
         tempz = Str$(CustomColorList.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), tempz, INIFileName
      Next

   End If
End Sub

Sub ZoomIn
   If NoCamera Then Exit Sub
End Sub

Sub ZoomOut
   If NoCamera Then Exit Sub
End Sub

Sub EnterCaption
   Local x,y,w,h As Long, temp$
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   temp$ = InputBox$("", "gbVideo - Enter Caption:", CaptionX, x+w/2-50,y+h/2-50)
   If Len(temp$) Then CaptionX = temp$
   UnhookWindowsHookEx ghHook
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr, iStyle As Long
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam : cst = @cw.lpcs                ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then
         Select Case @cst.hMenu
            Case %IdOk   :   @cst.x=20:@cst.y=40:@cst.cx=60
            Case %IdCancel : @cst.x=110:@cst.y=40:@cst.cx=60
         End Select
      End If
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400  'prompt moved out of the way
      If UCase$(szTemp) = "EDIT"   Then
         @cst.x = 10   : @cst.y = 10 : @cst.cx = 175 : @cst.cy = 30
         iStyle = GetWindowLong(wParam,%GWL_Style)
         SetWindowLong wparam, %GWL_Style, iStyle 'Or %ES_Password
      End If
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = 100  'dialog
   End If
End Function

Sub GetSettings
   Local i As Long
   Dim QName(12) As String
   Dim QDelta(12) As Long
   Dim QType(12) As Long
   Array Assign QName()  = "","Compensation","Brightness","Contrast","Gain","Gamma","Hue","Saturation","Sharpness", "White Balance", "Exposure", "Focus", "Zoom"
   Array Assign QDelta() = 0,0,12,12,12,0,0,12,12,300,1,25,40                                            'Size of change increments
   Array Assign QType()  = 0,%VideoProcAmp_BacklightCompensation, %VideoProcAmp_Brightness, %VideoProcAmp_Contrast, %VideoProcAmp_Gain, _
                           %VideoProcAmp_Gamma, %VideoProcAmp_Hue, %VideoProcAmp_Saturation, %VideoProcAmp_Sharpness, _
                           %VideoProcAmp_WhiteBalance, %CameraControl_Exposure, %CameraControl_Focus, %CameraControl_Zoom
   pProcAmp    = pCap
   pCamControl = pCap
   ReDim Q(12)
   For i = 1 To 12   '1-9 are quality setting pProcAmp : 10-12 are Camera control settings
      If i < 10 Then pProcAmp.GetRange(QType(i), Q(i).Min, Q(i).Max, Q(i).Step, Q(i).Default, 0)
      If i < 10 Then pProcAmp.Get(QType(i), Q(i).Val, 0)
      If i > 9  Then pCamControl.GetRange(%CameraControl_Exposure, Q(10).Min, Q(10).Max, Q(10).Step, Q(10).default, 0)
      If i > 9  Then pCamControl.Get(%CameraControl_Exposure, Q(10).Val, 0)
      Q(i).name  = QName(i)
      Q(i).delta = QDelta(i)
      Q(i).type  = QType(i)
   Next i
End Sub

Sub LoadListView
   If NoCamera Then ListType = %ListType_None
   Local i As Long
   ListView Reset hDlg, %IDC_ListView
   Select Case ListType
      Case %ListType_Cameras
         ListView Set Header hDlg, %IDC_ListView, 1, "Camera"
         ListView Set Header hDlg, %IDC_ListView, 2, "Resolution"
         ListView Set Header hDlg, %IDC_ListView, 3,""
         ListView Set Header hDlg, %IDC_ListView, 4,""
         ListView Set Column hDlg, %IDC_ListView, 1, 250
         ListView Set Column hDlg, %IDC_ListView, 2, 100
         ListView Set Column hDlg, %IDC_ListView, 3, 0
         ListView Set Column hDlg, %IDC_ListView, 4, 0
         If NoCamera Then
            ListView Insert Item hDlg, %IDC_ListView, 1, 0, "No Cameras Found"
         Else
            For i = 1 To UBound(Cameras)
               ListView Insert Item hDlg, %IDC_ListView, i, 0, Cameras(i)
               If Cameras(i) = CameraName Then
                  ListView Select hDlg, %IDC_ListView, i
                  ListView_SetItemState hListView, i-1, %LVIS_Focused, %LVIS_Focused  '<--- synchronizing code
               End If
            Next i
         End If

      Case %ListType_Quality
         ListView Set Header hDlg, %IDC_ListView, 1,"Quality Setting"
         ListView Set Header hDlg, %IDC_ListView, 2,"Val"
         ListView Set Header hDlg, %IDC_ListView, 3,"Min"
         ListView Set Header hDlg, %IDC_ListView, 4,"Max"
         ListView Set Column hDlg, %IDC_ListView, 1, 170
         ListView Set Column hDlg, %IDC_ListView, 2, 60
         ListView Set Column hDlg, %IDC_ListView, 3, 60
         ListView Set Column hDlg, %IDC_ListView, 4, 60
         For i = 1 To UBound(Q)
            ListView Insert Item hDlg, %IDC_ListView, i,0, Q(i).name
            ListView Set Text hDlg, %IDC_ListView, i, 2, Str$(Q(i).val)
            ListView Set Text hDlg, %IDC_ListView, i, 3, Str$(Q(i).min)
            ListView Set Text hDlg, %IDC_ListView, i, 4, Str$(Q(i).max)
         Next i
         ListView Select hDlg, %IDC_ListView, 1
         ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- synchronizing code
   End Select
   Control Set Focus hDlg, %IDC_ListView
End Sub

Sub SelectCameraName
   Local i,iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, i, 1 To temp$
      If temp$ = CameraName Then ListView Select hDlg, %IDC_ListView, i : Exit For
   Next i
End Sub

Sub NextCamera
   If NoCamera Then Exit Sub
   Local i As Long
   For i = 1 To UBound(Cameras)
      If Cameras(i) = CameraName Then
         i = i + 1
         If i > UBound(Cameras) Then i = 1
         Exit For
      End If
   Next i
   ChangeCamera(Cameras(i))
End Sub

Sub ChangeCamera(NewCameraName$)
   If NoCamera Then Exit Sub
   pControl.Stop
   CameraName = NewCameraName$
   ResetObjects
   DisplayVideo
   ResizeWindow
   SetMenusAndToolbar
   GetSettings
End Sub

Sub ResetObjects
'   pControl.Stop
   pGraph      = Nothing
   pBuild      = Nothing
   pSysDevEnum = Nothing

   'GetCameraList
   pEnumCat    = Nothing
   pPropBag    = Nothing
   pMoniker    = Nothing
   pbc         = Nothing

   'DipslayVideo
   pWindow     = Nothing
   pCap        = Nothing
   pControl    = Nothing

   pConfig     = Nothing
   pProcAmp    = Nothing
   pCamControl = Nothing

End Sub

Function IsPrinterAttached() As Long
On Error GoTo AttachError:
   XPrint Attach Default
   XPrint Close
   Function = 1
Exit Function
AttachError:
End Function

Sub CopyToClipboard
   If NoCamera Then Exit Sub
   Local hBMP, hBMPDC, hDialogDC As Dword

   'create memory bitmap the size of the dialog
   Graphic Bitmap New wMod+2*BorderSize,hMod+2*BorderSize To hBMP
   Graphic Attach hBMP,0
   Graphic Get DC To hBMPDC

   'bitblt dialog rectangle from the screen to the memory bitmap
   hDialogDC = GetDC(hDlg)
   BitBlt hBMPDC, 0,0,wMod+2*BorderSize,hMod+2*BorderSize, hDialogDC, xImg-BorderSize, yImg-BorderSize, %SRCCopy 'copy desktop image to
   ReleaseDC(%Null,hDialogDC)

   'caption
   If ShowCaption Then
      Graphic Color TextColor, BGColor
      Graphic Set Font hFont
      Graphic Set Pos (0,0)
      Graphic Print CaptionX
   End If

   'save to file
   Incr CopyCount
   Graphic Save Exe.Path$ + "images\gbvideo_" + Format$(CopyCount,"00000") + ".bmp"

   'send to clipboard
   Clipboard Reset
   Clipboard Set Bitmap hBMP

   Play Wave "xcamera"
End Sub

Function captionHeight(hWnd As Dword) As Long
   Local cw,ch,ddw,ddh As Long
   Dialog Get Size hWnd To ddw,ddh
   Dialog Get Client hWnd To cw,ch
   Function = ddh-ch
End Function

Sub PrintImage
   If IsPrinterAttached = 0 Then Beep : Exit Sub
   Local PrinterOrientation As Long
   Local x,y,wNew,hNew,wCont,hCont As Long
   Local hDC_Dialog, hDC_Printer, deskDC As Dword
   Local gXppi, gyPPI, pXppi, pYppi As Long, rc As Rect

   'Select Printer
   XPrint Attach Default
   If Len(XPrint$)=0 Then Exit Sub

   'Get Printer Properties
   XPrint Get Client To wCont, hCont
   XPrint Get PPI To pXppi, pYppi
   XPrint Get DC To hDC_Printer

   'Get Screen PPI
   deskDC = GetDC(%HWND_Desktop)
   gXppi = GetDeviceCaps(deskDC, %LogPixelsX)
   gYppi = GetDeviceCaps(deskDC, %LogPixelsX)
   ReleaseDC %HWND_Desktop, deskDC

   hDC_Dialog = GetDC (hDlg)
   wNew = (wMod+2*BorderSize) / Max((wMod+2*BorderSize) / wCont, (hMod+2*BorderSize) / hCont)
   hNew = (hMod+2*BorderSize) / Max((wMod+2*BorderSize) / wCont, (hMod+2*BorderSize) / hCont)
   x = (wCont-wNew)/2 : y = (hCont-hNew)/2 'upper/left position so resized image is centered

   'Print
   PrinterOrientation = 1
   XPrint Get Orientation To PrinterOrientation
   StretchBlt hDC_Printer,x,y,wNew,hNew, hDC_Dialog,xImg-BorderSize,yImg-BorderSize,wMod+2*BorderSize,hMod+2*BorderSize, %SRCCopy

   ReleaseDC hDlg, hDC_Dialog
   XPrint Close
End Sub

Sub CreateInterfaces
   pGraph      = NewCom ClsId $CLSID_FilterGraph                              'filter graph
   pBuild      = NewCom ClsId $CLSID_CaptureGraphBuilder2                     'capture graph builder
   pSysDevEnum = NewCom ClsId $CLSID_SystemDeviceEnum                         'enumeration object
'   pGrabber    = NewCom ClsId $CLSID_SampleGrabber
End Sub

Sub GetCameraList  'stops enumeration on moniker which has the friendly name
   Local pceltFetched As Dword, pwszDisplayName As WStringZ Ptr, varName As Variant
   ReDim Cameras(100)
   CameraCount = 0
   hr = pSysDevEnum.CreateClassEnumerator($CLSID_VideoInputDeviceCategory, pEnumCat, 0)  'list of monikers
   If hr = %S_False Then NoCamera = 1 : Exit Sub
   Do
      hr = pEnumCat.next(1, pMoniker, pceltFetched)                               'cycle through monikders
      If hr = %S_False Then Exit Do                                               'stop when no more monitors
      hr = pMoniker.GetDisplayName(pbc, Nothing, pwszDisplayName)                 'get complex camera name
      hr = pMoniker.BindToStorage(Nothing, Nothing, $IID_IPropertyBag, pPropBag)  'get info about Moniker
      hr = pPropBag.Read("FriendlyName", varName, Nothing)                        'get friendly name
      Incr CameraCount : Cameras(CameraCount) = Variant$$(varName)
   Loop
   ReDim Preserve Cameras(CameraCount)
End Sub

Sub DisplayVideo
   If NoCamera Then Exit Sub
   GetMatchingMoniker                                                         'moniker matching friendly name
   hr = pMoniker.BindToObject(Nothing, Nothing, $IID_IBaseFilter, pCap)       'create device filter for the chosen device
   hr = pGraph.AddFilter(pCap,CameraName)                                     'add chosen device filter to the filter graph
   hr = pBuild.SetFilterGraph(pGraph)                                         'initialize pBuild
   pBuild.RenderStream $Pin_Category_Preview, $MediaType_Video, pCap, Nothing, Nothing   'render the live source
   pWindow = pGraph : pWindow.Owner = hDlg : pWindow.WindowStyle = %WS_Child Or %WS_ClipSiblings Or %WS_ClipChildren 'video window settings
   pControl = pGraph
   pControl.Run
End Sub

Sub GetMatchingMoniker  'stops enumeration on moniker which has the friendly name
   Local pceltFetched As Dword, pwszDisplayName As WStringZ Ptr, varName As Variant
   hr = pSysDevEnum.CreateClassEnumerator($CLSID_VideoInputDeviceCategory, pEnumCat, 0)  'list of monikers
   Do
      hr = pEnumCat.next(1, pMoniker, pceltFetched)                               'cycle through monikers
      If hr = %S_False Then Exit Do                                               'stop when no more monitors
      hr = pMoniker.GetDisplayName(pbc, Nothing, pwszDisplayName)                 'get complex camera name
      hr = pMoniker.BindToStorage(Nothing, Nothing, $IID_IPropertyBag, pPropBag)  'get info about Moniker
      hr = pPropBag.Read("FriendlyName", varName, Nothing)                        'get friendly name
      If Variant$$(varName) = CameraName Then Exit Do
   Loop
End Sub

Sub SetCameraRC
   CameraRC.nLeft   = xImg - BorderSize
   CameraRC.nTop    = yImg - BorderSize
   CameraRC.nRight  = CameraRC.nLeft + wMod + 2*BorderSize
   CameraRC.nBottom = CameraRC.nTop + hMod + 2*BorderSize
End Sub

Sub ToggleBorderSize
   Select Case BorderSize
      Case 0  : BorderSize = 1
      Case 1  : BorderSize = 2
      Case 2  : BorderSize = 5
      Case 5  : BorderSize = 10
      Case 10 : BorderSize = 15
      Case 15 : BorderSize = 0
      Case Else : BorderSize = 0
   End Select
End Sub

Sub ToggleBinaryMode
   Incr BinaryMode : If BinaryMode > 4 Then BinaryMode = 0
   Select Case BinaryMode    'determines if binary colors are shown (frame processing)
      Case 0 : BinaryMode = 1 : TextColor = %Black  : BGColor = %White
      Case 1 : BinaryMode = 2 : TextColor = %White  : BGColor = %Black
      Case 2 : BinaryMode = 3 : TextColor = %Yellow : BGColor = %Blue
      Case 3 : BinaryMode = 4 : TextColor = %White  : BGColor = %Blue
      Case 4 : BinaryMode = 0
   End Select
End Sub

Sub RestoreDefaultSettings
   Local i,iRow As Long
   ListView Get Select hDlg, %IDC_ListView To i
   For i = 1 To 9   : SetCameraSettings(Q(i).type, Q(i).default) : Next i
   For i = 10 To 12 : SetCameraSettings(Q(i).type, Q(i).default) : Next i
   GetSettings
   LoadListView
   ListView Select hDlg, %IDC_ListView, i
End Sub

Sub SetCameraSettings(iType As Long, NewValue As Long)
   Local i As Long
   If iType < 10 Then pProcAmp.Set(iType, NewValue, 0)
   If iType > 9  Then pCamControl.Set(iType, NewValue, 0)
End Sub

Sub ChangeSetting(iDirection As Long)
   Local iRow,iNew As Long
   ListView Get Select hDlg, %IDC_ListView To iRow

   iNew = Q(iRow).val + iDirection * Q(iRow).Delta
   If iNew < Q(iRow).min Then iNew = Q(iRow).min
   If iNew > Q(iRow).max Then iNew = Q(iRow).max

   If iRow < 10 Then pProcAmp.Set(Q(iRow).type, iNew, 0)
   If iRow > 9  Then pCamControl.Set(Q(iRow).type, iNew, 0)

   GetSettings
   LoadListView
   ListView Select hDlg, %IDC_ListView, iRow
End Sub

Sub ToggleMiniBar
   Local w,h As Long
   Dialog Get Size hDlg To w,h
   MiniBar Xor=1
   If MiniBar Then
      ListType = %ListType_None
      Dialog Set Size hDlg, 470,430
   Else
      Dialog Set Size hDlg, Max(w,960),h
      '
   End If
   CreateToolbar : ResizeWindow : SetMenusAndToolbar
End Sub

'Sub GetCameraSettings
'   Local i As Long
'   'Array assignments
'   Array Assign Q()      = "","Compensation","Brightness","Contrast","Gain","Gamma","Hue","Saturation", _   'Name of Settings
'                           "Sharpness", "White Balance", "Exposure", "Focus", "Zoom"
'   Array Assign QDelta() = 0,12,12,12,0,0,12,12,300,1,25,40                                            'Size of change increments
'   Array Assign QType()  = %VideoProcAmp_BacklightCompensation, %VideoProcAmp_Brightness, %VideoProcAmp_Contrast, %VideoProcAmp_Gain, _
'                           %VideoProcAmp_Gamma, %VideoProcAmp_Hue, %VideoProcAmp_Saturation, %VideoProcAmp_Sharpness, _
'                           %VideoProcAmp_WhiteBalance, %CameraControl_Exposure, %CameraControl_Focus
'   'create needed interfaces
'   pProcAmp    = pCap
'   pCamControl = pCap
'   'get values from camera
'   For i = 1 To 12
'      If i < 10 Then pProcAmp.GetRange(QType(i), Q(i).Min, Q(i).Max, Q(i).Step, Q(i).Default, 0)
'      If i < 10 Then pProcAmp.Get(%VideoProcAmp_BacklightCompensation, Q(i).Val, 0)
'      If i > 9  Then pCamControl.GetRange(QType(i), Q(i).Min, Q(i).Max, Q(i).Step, Q(i).default, 0)
'      If i > 9  Then pCamControl.Get(%CameraControl_Zoom, Q(i).Val, 0)
'   Next i
'End Sub
'
'Sub ResetCameraSettings
'   Local i As Long
'   For i = 1 To 9   : SetCameraSettings(QType(i), Q(i).default) : Next i
'   For i = 10 To 12 : SetCameraSettings(QType(i), Q(i).default) : Next i
'End Sub
'
'Sub SetCameraSettings(iType As Long, NewValue As Long)
'   Local i As Long
'   If iType < 10 Then pProcAmp.Set(iType, NewValue, 0)
'   If iType > 9  Then pCamControl.Set(iType, NewValue, 0)
'End Sub
'
'Sub IncreaseSetting
'End Sub
'
'Sub DecreaseSetting
'End Sub
